	' !!IMPORTANT!!
	' BY DEFAULT, THIS PRICE SCRIPT EXPECTS TO BE PLACED IN THE "PRICES" FOLDER UNDER THE MAGIC ALBUM APPLICATION FOLDER
	' IT IS RECOMMENDED YOU UPDATE THE 'strRootFolder' VARIABLE TO POINT TO THE MAGIC ALBUM APPLICATION FOLDER
	' YOU MUST HAVE WRITE PERMISSIONS TO THE 'strRootFolder' LOCATION DEFINED BELOW IN ORDER TO CREATE THE CATALOG,TEMP,DEBUG, AND PRICE FILES
	' !!IMPORTANT!!
	
	' !!NOTE!!
	' THIS SCRIPT SUPPORTS ARGUMENTS, YOU MAY PASS THE FOLLOWING ARGUMENTS IN TO SET VARIABLES ACCORDINGLY
	' IF ARGUMENT IS NOT PASSED TO SCRIPT, DEFAULTS LISTED BELOW ARE USED
	' ARGUMENTS: SETNAME,BLOCKNAME,DEBUGMODE,ROOTFOLDER,TEMPFILE,DEBUGFILE,PRICEFILE,VERBOSEMODE,FORMAT,PRICEVALUE
	' EXAMPLE:
	' Template.vbs pricevalue="average" format="standard" cardfoiling="nonfoil" language="english" setname="ALL" blockname="ALL" debugmode="off" rootfolder="c:\magic album" tempfile="c:\sitetemp.txt" debugfile="c:\sitedebug.txt" pricefile="c:\siteprice.txt" verbosemode="off" 
	' !!NOTE!!
	
	
	Set Args = WScript.Arguments
	Dim strRunTime,strLanguageToCollect,strCardFoilingToCollect,strVerifyBeforeAdd,strBlockNameToCollect,strSetNameToCollect,strFormatToCollect,strUserInput,strStartTime,strEndTime,strDebugMode,ArrPageCount(),ArrSetName(),ArrSetURL(),ArrBlock(),ArrFormat(),ArrStandardFormatSets,ArrExtendedFormatSets,strScriptVersion,strSiteName,strVerboseMode,strRootFolder,strCatalogTempFile,strTempFile,strDebugFile,strPriceFile,strSiteURLHeader,strCatalogURL,strPriceValueToCollect
	ArrStandardFormatSets = Array("Dark Ascension","Innistrad","Magic 2012","New Phyrexia","Mirrodin Besieged","Scars of Mirrodin")
	ArrExtendedFormatSets = Array("Magic 2011","Rise of the Elrazi","Worldwake","Zendikar","Magic 2010","Alara Reborn","Conflux","Shards of Alara")
	strScriptVersion = "2.0"
	strSiteName = "MTGMintCard"
	strVerboseMode = "off"	'off,on
	strDebugMode = "off"	'off,on
	strRootFolder = "..\"
	strCatalogTempFile = strRootFolder & strSiteName & "_catalog.tmp"
	strTempFile = strRootFolder & strSiteName & "_webdata.tmp"
	strDebugFile = strRootFolder & strSiteName & "_debug.tmp"
	strPriceFile = strRootFolder & strSiteName & ".txt"
	strCatalogURL = "http://m.mtgmintcard.com/mtg_category.php"
	strSiteURLHeader = ""
	strSetNameToCollect = "none"
	strFormatToCollect = "standard"	'standard,extended
	strBlockNameToCollect = "none"
	strVerifyBeforeAdd = "yes"	'yes,no
	strCardFoilingToCollect = "nonfoil"
	strLanguageToCollect = "english"
	strPriceValueToCollect = "average"	'price,average,high,low (only used if site support multi-pricing)

	strStartTime = Now()
	DefineGlobalArguments
	If Not LCase(strVerboseMode) = "off" Then
		strUserInput = MsgBox("Verify you have opened the script in a command window otherwise popups between sets will occur and require user interaction." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Verbose Mode [" & UCase(strVerboseMode) & "]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	
	If (LCase(strSetNameToCollect) = "all") Or (LCase(strBlockNameToCollect) = "all") Then
		strUserInput = MsgBox("Setting either set name or block name to collect all information can take a substancial amount of time." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Set/Blocks to collect set to [ALL]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	If Not Right(strRootFolder,1) = "\" Then : strRootFolder = strRootFolder & "\" : End If
	PreProcesses
	DefineKnownSets
	CollectAvailableSets strCatalogURL,strCatalogTempFile
	'DumpArrayInformation "no"
	CollectSetDetails
	PostProcesses
	strEndTime= Now()
	strRunTime = DateDiff("n",strStartTime,strEndTime)
	If Int(strRunTime) < 1 Then : strRunTime = "<1" : End If
	If LCase(strVerboseMode) = "on" Then : WScript.Echo "It took [" & strRunTime & "] minutes to collect all the data" : End If

	Sub DefineGlobalArguments()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim colArgumentSplit
		For Each Argument in Args
			If InStr(Argument,"=") Then
				'define passed in argument variable information
				If InStr(LCase(Argument),LCase("setname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strSetNameToCollect = CorrectSetName(colArgumentSplit(1))
					End If
				End If

				If InStr(LCase(Argument),LCase("blockname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strBlockNameToCollect = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugmode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugMode = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("rootfolder=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strRootFolder = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("verifybeforeadd=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerifyBeforeAdd = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("tempfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strTempFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("pricefile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strPriceFile = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("verbosemode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerboseMode = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("language=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strLanguageToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("cardfoiling=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strCardFoilingToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("format=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strFormatToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("pricevalue=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strPriceValueToCollect = colArgumentSplit(1)
					End If
				End If
			Else
				'improperly formated argument passed
			End If
		Next
	End Sub

	Sub DefineKnownSets()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Populating predefined product information" : End If
		Dim intNewArraySize
		intNewArraySize = 0
		
		'declare set array information
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)

		' Example: 
		'	Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
		'	ArrPageCount(intNewArraySize) = 21 : ArrSetName(intNewArraySize) = "Magic 2012" : ArrSetURL(intNewArraySize) = "magic_singles-core_sets-magic_2012/702" : ArrBlock(intNewArraySize) = "Core Sets" : ArrFormat(intNewArraySize) = "Standard" : intNewArraySize = UBound(arrPageCount) + 1
		
		'--core sets
		'--innistrad block
		'--scars of mirrodin block
		'--zendikar block
		'--shares of alara block
		'--shadowmoor block
		'--lorwyn block
		'--time spiral block
		'--ravnica block
		'--kamigawa block
		'--mirrodin block
		'--onslaught block
		'--odyssey block
		'--invasion block
		'--masques block
		'--saga block
		'--tempest block
		'--ice age block
		'--mirage block
		'--stand alone sets
		'--special editions
		'--magic promos
		'--premium deck series
		'--duel decks
		'--from the vault
		
	End Sub

	Function HTTPDownload(myURL, strFile)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim i, objFile, objFSO, objHTTP, strResults
		strResults = "failed"
		Const ForReading = 1, ForWriting = 2, ForAppending = 8
		Set objFSO = CreateObject( "Scripting.FileSystemObject" )
		Set objFile = objFSO.OpenTextFile( strFile, ForWriting, True )
	    	Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
		objHTTP.Open "GET", myURL, False
		objHTTP.Send
		For i = 1 To LenB( objHTTP.ResponseBody )
			objFile.Write Chr( AscB( MidB( objHTTP.ResponseBody, i, 1 ) ) )
		Next
		objFile.Close( )
		strResults = "success"
		HTTPDownload = strResults
	End Function
	
	Sub WriteLog(strLogFile,strDataToWrite,strRecreate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim objFileSys,objFileOpenForAppending
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If LCase(strRecreate) = "delete" Then
			If objFileSys.FileExists(strLogFile) Then
				objFileSys.DeleteFile strLogFile,True
			End If
		Else
			If NOT objFileSys.FileExists(strLogFile) Then : objFileSys.CreateTextFile strLogFile : End If
			If (LCase(strRecreate) = "yes") Then : objFileSys.CreateTextFile strLogFile : End If
			Set objFileOpenForAppending = objFileSys.OpenTextFile(strLogFile,8)
			objFileOpenForAppending.WriteLine strDataToWrite
			objFileOpenForAppending.Close
			Set objFileOpenForReading = Nothing
		End If
	End Sub

	Sub DumpArrayInformation(strRecreate)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		For i = 0 To UBound(ArrSetName)
			WriteLog strDebugFile,"ArrPageCount(" & i & ") = " & """" & ArrPageCount(i) & """" & " : ArrSetName(" & i & ") = " & """" & ArrSetName(i) & """" & " : ArrSetURL(" & i & ") = " & """" & ArrSetURL(i) & """" & " : ArrBlock(" & i & ") = " & """" & ArrBlock(i) & """" & " : ArrFormat(" & i & ") = " & """" & ArrFormat(i) & """",strRecreate
		Next
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Set information dumped to debug file" : End If
	End Sub

	Function LocateStringInFile(strFile,strStringToLocate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		strResults = "NO"
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If objFileSys.FileExists(strFile) Then
			Set objFileOpenForReading = objFileSys.OpenTextFile(strFile,1)
			Do While objFileOpenForReading.AtEndOfStream <> True
				strCurrentReadLine = objFileOpenForReading.ReadLine
				If InStr(LCase(strCurrentReadLine),LCase(strStringToLocate)) Then
					strResults = "YES"
					Exit Do
				End If
			Loop
			objFileOpenForReading.Close
			Set objFileOpenForReading = Nothing
		End If
		Set objFileSys = Nothing
		If strResults = "" Then : strResults = "NO" : End If
		LocateStringInFile = strResults
	End Function

	Sub Folder(strFolderName,strFolderTask)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		Select Case LCase(strFolderTask)
			Case "create"
				objFileSys.CreateFolder strFolderName
			Case "recreate"
				If objFileSys.FolderExists(strFolderName) Then : objFileSys.DeleteFolder strFolderName : End If
				objFileSys.CreateFolder strFolderName
			Case "delete"
				If objFileSys.FolderExists(strFolderName) Then : objFileSys.DeleteFolder strFolderName : End If
			Case Else
		End Select
		Set objFileSys = Nothing
	End Sub
	
	Sub File(strFileName,strFileTask)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		Select Case LCase(strFileTask)
			Case "create"
				objFileSys.CreateTextFile strFileName
			Case "recreate"
				If objFileSys.FileExists(strFileName) Then : objFileSys.DeleteFile strFileName : End If
				objFileSys.CreateTextFile strFileName
			Case "delete"
				If objFileSys.FileExists(strFileName) Then : objFileSys.DeleteFile strFileName : End If
			Case Else
		End Select
		Set objFileSys = Nothing
	End Sub

	Sub PreProcesses()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Performing pre-requirement routine(s)" : End If
		File strCatalogTempFile,"recreate"
		File strTempFile,"recreate"
		File strDebugFile,"recreate"
		File strPriceFile,"recreate"
	End Sub

	Sub PostProcesses()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Performing cleanup routine(s)" : End If
		File strCatalogTempFile,"delete"
		File strTempFile,"delete"
		File strDebugFile,"delete"
	End Sub

	Function IdentifySetFormat(strSetToIdentify)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If	
		Dim strResults
		strResults = "Unknown"

		Select Case LCase(strSetToIdentify)
			Case "unglued"
			Case "unhinged"
			Case Else
				'check if set is in known standard set list
				If InStr(LCase(strResults),"standard") Then
					'do nothing, the set is already marked as in standard format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Standard"
							Else
								strResults = strResults & ",Standard"
							End If
							Exit For
						End If
					Next
				End If
				
				'check if set is in known extended set list
				If InStr(LCase(strResults),"extended") Then
					'do nothing, the set is already marked as in extended format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
					
					For Each strSet In ArrExtendedFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
				End If 
				
				'apply vintage & legacy
				If LCase(strResults) = "unknown" Then : strResults = "Legacy,Vintage" : Else : strResults = strResults & ",Legacy,Vintage" : End If
		
		End Select
				
		'return results
		IdentifySetFormat = strResults
		
	End Function
	
	Function IsSetAlreadyKnown(strSetName)
		If Not LCase(strDebugFile) = "on" Then : On Error Resume Next : End If
		Dim strResults
		strResults = "no"
		For Each strSet In ArrSetName
			If LCase(strSetName) = LCase(strSet) Then : strResults = "yes" : Exit For : End If
		Next
		IsSetAlreadyKnown = strResults
	End Function

'routines below should be customized based on site

	Function IdentifyBlockInformation(strSetName)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults
		strResults = ""		
		'there is no way to determin block information from site, manual entry would be required
		IdentifyBlockInformation = strResults
	End Function	

	Function IdentifyCardVersion(strCardName,strCardSet)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults
		Select Case LCase(strCardName)
			Case Else
		End Select
		If strResults = "" Then : strResults = "*" : End If
		IdentifyCardVersion = strResults
	End Function

	Function IdentifySetPageCount(strSetName,strSetURL)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim intHighestPageCount,intIdentifiedPageNumber,colReadLineSplitTwo,colReadLineSplitOne,strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		
		'declare variable(s) value(s)
		intHighestPageCount = 0
		
		'download set details
		strResults = HTTPDownload(strSetURL,strTempFile)
		If LCase(strResults) = "success" Then
			Set objFileSys = CreateObject("Scripting.FileSystemObject")
			If objFileSys.FileExists(strTempFile) Then
				Set objFileOpenForReading = objFileSys.OpenTextFile(strTempFile,1)
				Do While objFileOpenForReading.AtEndOfStream <> True
					strCurrentReadLine = objFileOpenForReading.ReadLine
					If InStr(LCase(strCurrentReadLine),LCase("class=" & """" & "page" & """")) Then
						colReadLineSplitOne = Split(strCurrentReadLine,"&osCsid=")
						For Each Item In colReadLineSplitOne
							colReadLineSplitTwo = Split(Item,"&char=")
							intIdentifiedPageNumber = colReadLineSplitTwo(UBound(colReadLineSplitTwo))
							If Len(intIdentifiedPageNumber) = 1 Then
								If Int(intHighestPageCount) < Int(intIdentifiedPageNumber) Then : intHighestPageCount = intIdentifiedPageNumber : End If
							End If
						Next
						Exit Do
					End If
				Loop
				objFileOpenForReading.Close
				Set objFileOpenForReading = Nothing
			End If
			Set objFileSys = Nothing
		End If
		strResults = intHighestPageCount
		IdentifySetPageCount = strResults
	End Function

	Function CorrectSetName(strSetNameToCorrect)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults
		Select Case strSetNameToCorrect
			Case "2012 Core Set" : strResults = "Magic 2012"
			Case "2011 Core Set" : strResults = "Magic 2011"
			Case "2010 Core Set" : strResults = "Magic 2010"
			Case "Time Spiral " & """" & "Timeshifted" & """" : strResults = "Time Spiral Timeshifted"
			Case "Core Set - Tenth Edition" : strResults = "Tenth Edition"
			Case "Core Set - Ninth Edition" : strResults = "9th Edition"
			Case "Core Set - Eighth Edition" : strResults = "8th Edition"
			Case "Seventh Edition" : strResults = "7th Edition"
			Case "Classic (Sixth Edition)" : strResults = "6th Edition"
			Case "Fifth Edition" : strResults = "5th Edition"
			Case "Fourth Edition" : strResults = "4th Edition"
			Case "Revised Edition[II]" : strResults = "Revised Edition"
			Case "Limited Edition Beta" : strResults = "Beta"
			Case "Limited Edition Alpha" : strResults = "Alpha"
			Case "Graveborn" : strResults = "Premium Deck Series: Graveborn"
			Case "Ajani vs. Nicol Bolas" : strResults = "Duel Decks: Ajani vs. Nicol Bolas"
			Case "Commander" : strResults = "Magic: The Gathering Commander"
			Case "Knights vs. Dragons" : strResults = "Duel Decks: Knights vs. Dragons"
			Case "Fire & Lightning" : strResults = "Premium Deck Series: Fire & Lightning"
			Case "Elspeth vs. Tezzeret" : strResults = "Duel Decks: Elspeth vs. Tezzeret"
			Case Else
		End Select
		If strResults = "" Then : strResults = strSetNameToCorrect : End If
		CorrectSetName = strResults
	End Function
	
	Function CorrectCardName(strCardNameToCorrect)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults,colCardNameSplitOne
		Select Case strCardNameToCorrect
			'Dark Ascension Double Faced Cards
			Case "Afflicted Deserter / Werewolf Ransacker" : strResults = "Afflicted Deserter|Werewolf Ransacker"
			Case "Chalice of Life / Chalice of Death" : strResults = "Chalice of Life|Chalice of Death"
			Case "Chosen of Markov / Markov's Servant" : strResults = "Chosen of Markov|Markovs Servant"
			Case "Elbrus, the Binding Blade / Withengar Unbound" : strResults = "Elbrus, the Binding Blade|Withengar Unbound"
			Case "Hinterland Hermit / Hinterland Scourge" : strResults = "Hinterland Hermit|Hinterland Scourge"
			Case "Huntmaster of the Fells / Ravager of the Fells" : strResults = "Huntmaster of the Fells|Ravager of the Fells"
			Case "Lambholt Elder / Silverpelt Werewolf" : strResults = "Lambholt Elder|Silverpelt Werewolf"
			Case "Loyal Cathar / Unhallowed Cathar" : strResults = "Loyal Cathar|Unhallowed Cathar"
			Case "Mondronen Shaman / Tovolar's Magehunter" : strResults = "Mondronen Shaman|Tovolars Magehunter"
			Case "Ravenous Demon / Archdemon of Greed" : strResults = "Ravenous Demon|Archdemon of Greed"
			Case "Scorned Villager / Moonscarred Werewolf" : strResults = "Scorned Villager|Moonscarred Werewolf"
			Case "Soul Seizer  / Ghastly Haunting" : strResults = "Soul Seizer|Ghastly Haunting"
			Case "Wolfbitten Captive / Krallenhorde Killer" : strResults = "Wolfbitten Captive|Krallenhorde Killer"
			
			'Innistrad Double Faced Cards
			Case "Villagers of Estwald / Howlpack of Estwald" : strResults = "Villagers of Estwald|Howlpack of Estwald"
			Case "Village Ironsmith / Ironfang" : strResults = "Village Ironsmith|Ironfang"
			Case "Ulvenwald Mystics / Ulvenwald Primordials" : strResults = "Ulvenwald Mystics|Ulvenwald Primordials"
			Case "Tormented Pariah / Rampaging Werewolf" : strResults = "Tormented Pariah|Rampaging Werewolf"
			Case "Thraben Sentry / Thraben Militia" : strResults = "Thraben Sentry|Thraben Militia"
			Case "Screeching Bat / Stalking Vampire" : strResults = "Screeching Bat|Stalking Vampire"
			Case "Reckless Waif / Merciless Predator" : strResults = "Reckless Waif|Merciless Predator"
			Case "Mayor of Avabruck / Howlpack Alpha" : strResults = "Mayor of Avabruck|Howlpack Alpha"
			Case "Ludevic's Test Subject / Ludevic's Abomination" : strResults = "Ludevics Test Subject|Ludevics Abomination"
			Case "Kruin Outlaw / Terror of Kruin Pass" : strResults = "Kruin Outlaw|Terror of Kruin Pass"
			Case "Instigator Gang / Wildblood Pack" : strResults = "Instigator Gang|Wildblood Pack"
			Case "Hanweir Watchkeep / Bane of Hanweir" : strResults = "Hanweir Watchkeep|Bane of Hanweir"
			Case "Grizzled Outcasts / Krallenhorde Wantons" : strResults = "Grizzled Outcasts|Krallenhorde Wantons"
			Case "Gatstaf Shepherd / Gatstaf Howler" : strResults = "Gatstaf Shepherd|Gatstaf Howler"
			Case "Garruk Relentless / Garruk, the Veil-Cursed" : strResults = "Garruk Relentless|Garruk, the Veil-Cursed"
			Case "Delver of Secrets / Insectile Aberration" : strResults = "Delver of Secrets|Insectile Aberration"
			Case "Daybreak Ranger / Nightfall Predator" : strResults = "Daybreak Ranger|Nightfall Predator"
			Case "Cloistered Youth / Unholy Fiend" : strResults = "Cloistered Youth|Unholy Fiend"
			Case "Civilized Scholar / Homicidal Brute" : strResults = "Civilized Scholar|Homicidal Brute"
			Case "Bloodline Keeper / Lord of Lineage" : strResults = "Bloodline Keeper|Lord of Lineage"
			
			'misspellings
			Case "Urabrask, the Hidden" : strResults = "Urabrask the Hidden"
			Case "Curse of the Nightly Haunt" : strResults = "Curse of the Nightly Hunt"
			Case "Elder Cather" : strResults = "Elder Cathar"
			Case "Life’s Finale" : strResults = "Lifes Finale"
			Case "Séance" : strResults = "Sance"
			
			Case Else
				'define generic name format routines (if necessary)
				If InStr(strCardNameToCorrect,"Forest (") Then : strResults = "Forest" : End If
				If InStr(strCardNameToCorrect,"Mountain (") Then : strResults = "Mountain" : End If
				If InStr(strCardNameToCorrect,"Swamp (") Then : strResults = "Swamp" : End If
				If InStr(strCardNameToCorrect,"Island (") Then : strResults = "Island" : End If
				If InStr(strCardNameToCorrect,"Plains (") Then : strResults = "Plains" : End If
				If InStr(strCardNameToCorrect,"Forest(") Then : strResults = "Forest" : End If
				If InStr(strCardNameToCorrect,"Mountain(") Then : strResults = "Mountain" : End If
				If InStr(strCardNameToCorrect,"Swamp(") Then : strResults = "Swamp" : End If
				If InStr(strCardNameToCorrect,"Island(") Then : strResults = "Island" : End If
				If InStr(strCardNameToCorrect,"Plains(") Then : strResults = "Plains" : End If
		End Select
		If strResults = "" Then : strResults = strCardNameToCorrect : End If
		CorrectCardName = strResults
	End Function
	
	Sub CollectAvailableSets(strWebSiteURL,strSaveFile)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Identifying site product information" : End If
		Dim colReadLineSplitThree,colReadLineSplitTwo,colReadLineSplitOne,strShouldWeAddThisSet,strShouldWeCollectThisSet,strResults,strCurrentReadLine,strIdentifiedSetName,strIdentifiedSetURL,strIdentifiedSetFormat,strIdentifiedSetBlock,strIdentifiedSetPageCount,intNewArraySize
		
		'define default variable values
		strCurrentReadLine = ""
		strResults = ""
		strIdentifiedSetName = ""
		strIdentifiedSetURL = ""
		strIdentifiedSetFormat = ""
		strIdentifiedSetBlock = ""
		strIdentifiedSetPageCount = ""
		strShouldWeCollectThisSet = "no"
		strShouldWeAddThisSet = "no"
		
		'download available site sets
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading product catalog information" : End If
		strResults = HTTPDownload(strWebSiteURL,strSaveFile)
		If LCase(strResults) = "success" Then
			Set objFileSys = CreateObject("Scripting.FileSystemObject")
			If objFileSys.FileExists(strSaveFile) Then
				Set objFileOpenForReading = objFileSys.OpenTextFile(strSaveFile,1)
				Do While objFileOpenForReading.AtEndOfStream <> True
					strCurrentReadLine = objFileOpenForReading.ReadLine
					If InStr(LCase(strCurrentReadLine),"edition=") Then
						colReadLineSplitOne = Split(strCurrentReadLine,"</a>")
						For Each Item In colReadLineSplitOne
							strShouldWeCollectThisSet = "no"
							
							'identify available set name
							colReadLineSplitTwo = Split(Item,">")
							strIdentifiedSetName = colReadLineSplitTwo(UBound(colReadLineSplitTwo))
							strIdentifiedSetName = CorrectSetName(strIdentifiedSetName)
							
							'identify available set url
							colReadLineSplitTwo = Split(Item,"""")
							colReadLineSplitThree = Split(colReadLineSplitTwo(UBound(colReadLineSplitTwo) - 1),"&osCsid=")
							strIdentifiedSetURL = colReadLineSplitThree(LBound(colReadLineSplitThree)) & "&char="
							
							'identify set format
							strIdentifiedSetFormat = IdentifySetFormat(strIdentifiedSetName)
							
							'identify set block
							strIdentifiedSetBlock = IdentifyBlockInformation(strIdentifiedSetName)
							
							'determin if we are interested in this set
							If LCase(strSetNameToCollect) = "all" Then
								strShouldWeCollectThisSet = "yes"
							Else
								If LCase(strIdentifiedSetName) = LCase(strSetNameToCollect) Then
									strShouldWeCollectThisSet = "yes"
								Else
									If LCase(strBlockNameToCollect) = "all" Then
										strShouldWeCollectThisSet = "yes"
									Else
										If LCase(strIdentifiedSetBlock) = LCase(strBlockNameToCollect) Then
											strShouldWeCollectThisSet = "yes"
										Else
											If InStr(LCase(strIdentifiedSetFormat),LCase(strFormatToCollect)) Then
												strShouldWeCollectThisSet = "yes"
											End If
										End If
									End If
								End If
							End If
							
							'add set information to array if we are interested in the set
							If LCase(strShouldWeCollectThisSet) = "yes" Then
								strShouldWeAddThisSet = IsSetAlreadyKnown(strIdentifiedSetName)
								If LCase(strShouldWeAddThisSet) = "no" Then
									strIdentifiedSetPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
									intNewArraySize = UBound(ArrSetName) + 1
									Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
									ArrPageCount(intNewArraySize) = strIdentifiedSetPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedSetBlock : ArrFormat(intNewArraySize) = strIdentifiedSetFormat
									If LCase(strVerboseMode) = "on" Then : WScript.Echo "-->Identified [" & strIdentifiedSetName & "] set" : End If
								End If
							End If
		
						Next
					End If
				Loop
				objFileOpenForReading.Close
				Set objFileOpenForReading = Nothing
			End If
		End If
	End Sub

	Sub CollectSetDetails()
		'If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Identifying detailed set information" : End If
		Dim colCardBlockLineSplitTwo,colCardBlockLineSplitOne,colCardBlockSplit,strResults,strCurrentReadLine,strIdentifiedCardName,strIdentifiedCardPrice,strIdentifiedCardVersion,strCardBlockOpen,strCardBlockClosed,strCardBlock
		
		'define default variables
		strResults = ""
		strCurrentReadLine = ""
		strIdentifiedCardName = ""
		strIdentifiedCardPrice = ""
		strIdentifiedCardVersion = ""
		strCardBlockOpen = "no"
		strCardBlockClosed = "no"
		strCardBlock = ""
		
		For i = 0 To UBound(ArrSetName)
			If Not ArrSetName(i) = "" Then
				'download set details
				If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading [" & ArrSetName(i) & "] details on (" & Now() & ")" : End If
				For j = 0 To Int(ArrPageCount(i))
					strResults = HTTPDownload(ArrSetURL(i) & j,strTempFile)
					If LCase(strResults) = "success" Then
						Set objFileSys = CreateObject("Scripting.FileSystemObject")
						If objFileSys.FileExists(strTempFile) Then
							Set objFileOpenForReading = objFileSys.OpenTextFile(strTempFile,1)
							Do While objFileOpenForReading.AtEndOfStream <> True
								strCurrentReadLine = objFileOpenForReading.ReadLine
								If InStr(LCase(strCurrentReadLine),"<tr>") Then : strCardBlockOpen = "yes" : End If
								If LCase(strCardBlockOpen) = "yes" Then
									If strCardBlock = "" Then
										strCardBlock = strCurrentReadLine
									Else
										strCardBlock = strCardBlock & vbCrLf & strCurrentReadLine
									End If
									If InStr(LCase(strCurrentReadLine),"</tr>") Then : strCardBlockClosed = "yes" : End If
									If LCase(strCardBlockClosed) = "yes" Then

										'process located card block
										If InStr(strCardBlock,"&nbsp") Then
											'head block, skip
										Else
											colCardBlockSplit = Split(strCardBlock,vbCrLf)
											For Each Line In colCardBlockSplit
												'identify card name from card block
												If InStr(LCase(Line),"mtg_search_result.php") Then
													colCardBlockLineSplitOne = Split(Line,"</a>")
													colCardBlockLineSplitTwo = Split(colCardBlockLineSplitOne(UBound(colCardBlockLineSplitOne) - 1),">")
													strIdentifiedCardName = colCardBlockLineSplitTwo(UBound(colCardBlockLineSplitTwo))
												End If
												If Not strIdentifiedCardName = "" Then : strIdentifiedCardName = CorrectCardName(Trim(strIdentifiedCardName)) : End If
												
												'identify card price from card block
												If InStr(LCase(Line),"money") Then
													colCardBlockLineSplitOne = Split(Line,"</td>")
													colCardBlockLineSplitTwo = Split(colCardBlockLineSplitOne(LBound(colCardBlockLineSplitOne)),">")
													strIdentifiedCardPrice = colCardBlockLineSplitTwo(UBound(colCardBlockLineSplitTwo))
												End If
												
												If Not (strIdentifiedCardName = "") Then
													If Not (strIdentifiedCardPrice = "") Then
														'identify card version
														strIdentifiedCardVersion = IdentifyCardVersion(strIdentifiedCardName,ArrSetName(i))
														
														'write located card value to price File
														WriteLog strPriceFile,strIdentifiedCardName & vbTab & strIdentifiedCardPrice & vbTab & ArrSetName(i) & vbTab & LCase(strLanguageToCollect) & vbTab & strIdentifiedCardVersion & vbTab & LCase(strCardFoilingToCollect),"no"
														
														'exit card block
														Exit For
													End If
												End If												
											Next
										End If
										
										'cleared previous card block data
										strIdentifiedCardName = ""
										strIdentifiedCardPrice = ""
										strIdentifiedCardVersion = ""
										strCardBlock = ""
										strCardBlockOpen = "no"
										strCardBlockClosed = "no"
										
									End If
								End If
							Loop
							objFileOpenForReading.Close
							Set objFileOpenForReading = Nothing
						End If
						Set objFileSys = Nothing
					End If
				Next
			End If
		Next
		
	End Sub
	
